# Welcome to Serverless!
#
# This file is the main config file for your service.
# It's very minimal at this point and uses default values.
# You can always add more config options for more control.
# We've included some commented out config examples here.
# Just uncomment any of them to get that config option.
#
# For full config options, check the docs:
#    docs.serverless.com
#
# Happy Coding!

service: transcribe
#app: your-app-name
#tenant: your-tenant-name

# You can pin your service to only deploy with a specific Serverless version
# Check out our docs for more details
# frameworkVersion: "=X.X.X"

plugins:
  - serverless-plugin-tracing

provider:
  apiGateway:
    binaryMediaTypes:
      - 'audio/wav'
  name: aws
  runtime: python3.7

# you can overwrite defaults here
  stage: dev
  region: us-west-2
  tracing: true

# you can add statements to the Lambda function's IAM Role here
  iamRoleStatements:
    - Effect: "Allow"
      Action:
        - "s3:*"
        - "cloudwatch:*"
        - "transcribe:*"
        - "dynamodb:*"
        - "comprehend:*"
        - "apigateway:*"
        - "sts:*"
        - xray:PutTraceSegments
        - xray:PutTelemetryRecords
      Resource: "*"
#    - Effect: "Allow"
#      Action:
#        - "s3:PutObject"
#      Resource:
#        Fn::Join:
#          - ""
#          - - "arn:aws:s3:::"
#            - "Ref" : "ServerlessDeploymentBucket"
#            - "/*"

# you can define service wide environment variables here
#  environment:
#    variable1: value1

# you can add packaging information here
#package:
#  include:
#    - include-me.py
#    - include-me-dir/**
#  exclude:
#    - exclude-me.py
#    - exclude-me-dir/**

functions:
  trigger_transcribe:
    handler: trigger_transcribe.run
#    The following are a few example events you can configure
#    NOTE: Please make sure to change your handler code to work with those events
#    Check the event documentation for details
    events:
#      - http:
#          path: users/create
#          method: get
#      - websocket: $connect
      - s3:
          bucket: "uploaded-recorded"
          event: s3:ObjectCreated:*
          rules:
            - suffix: wav
#      - schedule: rate(10 minutes)
#      - sns: greeter-topic
#      - stream: arn:aws:dynamodb:region:XXXXXX:table/foo/stream/1970-01-01T00:00:00.000
#      - alexaSkill: amzn1.ask.skill.xx-xx-xx-xx
#      - alexaSmartHome: amzn1.ask.skill.xx-xx-xx-xx
#      - iot:
#          sql: "SELECT * FROM 'some_topic'"
#      - cloudwatchEvent:
#          event:
#            source:
#              - "aws.ec2"
#            detail-type:
#              - "EC2 Instance State-change Notification"
#            detail:
#              state:
#                - pending
#      - cloudwatchLog: '/aws/lambda/hello'
#      - cognitoUserPool:
#          pool: MyUserPool
#          trigger: PreSignUp
#      - alb:
#          listenerArn: arn:aws:elasticloadbalancing:us-east-1:XXXXXX:listener/app/my-load-balancer/50dc6c495c0c9188/
#          priority: 1
#          conditions:
#            host: example.com
#            path: /hello

#    Define function environment variables here
#    environment:
#      variable2: value2

  trigger_comprehend:
    handler: trigger_comprehend.run
    events:
#      - http:
#          path: users/create
#          method: get
#      - websocket: $connect
      - s3:
          bucket: "transcribed-record"
          event: s3:ObjectCreated:*
          rules:
            - suffix: json

  get_summary:
    handler: get_summary.run
    events:
      - http:
          path: summary
          method: get
          cors: "*"
          headers: "*"
  
  get_detail:
    handler: get_detail.run
    events:
      - http:
          path: detail/{uuid_str}
          method: get
          cors: "*"
          headers: "*"
          request:
            parameters:
              paths:
                uuid_str: true
  
  get_signed_url:
    handler: get_signed_url.run
    events:
      - http:
          path: signed_url/{file_name}
          method: get
          cors: "*"
          headers: "*"
          request:
            parameters:
              paths:
                file_name: true

# you can add CloudFormation resource templates here
resources:
  Resources:
    DynamoDbTable:
      Type: "AWS::DynamoDB::Table"
      Properties:
        AttributeDefinitions:
          -
            AttributeName: id
            AttributeType: S
        KeySchema:
          -
            AttributeName: id
            KeyType: HASH

        ProvisionedThroughput:
          ReadCapacityUnits: 1
          WriteCapacityUnits: 1
        TableName: transcription_table
#  Outputs:
#     NewOutput:
#       Description: "Description for the output"
#       Value: "Some output value"
